diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-simple-epc-backhaul.cc ns-3.31/src/lte/examples/lena-simple-epc-backhaul.cc
--- ns-3.30.1/src/lte/examples/lena-simple-epc-backhaul.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-simple-epc-backhaul.cc	2020-06-27 17:38:30.000000000 -0700
@@ -60,7 +60,7 @@
   bool useHelper = false;
 
   // Command line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("numNodePairs", "Number of eNodeBs + UE pairs", numNodePairs);
   cmd.AddValue ("simTime", "Total duration of the simulation", simTime);
   cmd.AddValue ("distance", "Distance between eNBs [m]", distance);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-simple-epc.cc ns-3.31/src/lte/examples/lena-simple-epc.cc
--- ns-3.30.1/src/lte/examples/lena-simple-epc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-simple-epc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -51,7 +51,7 @@
   bool disablePl = false;
 
   // Command line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("numNodePairs", "Number of eNodeBs + UE pairs", numNodePairs);
   cmd.AddValue ("simTime", "Total duration of the simulation", simTime);
   cmd.AddValue ("distance", "Distance between eNBs [m]", distance);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-simple-epc-emu.cc ns-3.31/src/lte/examples/lena-simple-epc-emu.cc
--- ns-3.30.1/src/lte/examples/lena-simple-epc-emu.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-simple-epc-emu.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,7 +55,7 @@
   double interPacketInterval = 1000;
 
   // Command line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue("nEnbs", "Number of eNBs", nEnbs);
   cmd.AddValue("nUesPerEnb", "Number of UEs per eNB", nUesPerEnb);
   cmd.AddValue("simTime", "Total duration of the simulation [s])", simTime);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-uplink-power-control.cc ns-3.31/src/lte/examples/lena-uplink-power-control.cc
--- ns-3.30.1/src/lte/examples/lena-uplink-power-control.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-uplink-power-control.cc	2020-06-27 17:38:30.000000000 -0700
@@ -45,12 +45,12 @@
   Config::SetDefault ("ns3::LteUePowerControl::AccumulationEnabled", BooleanValue (true));
   Config::SetDefault ("ns3::LteUePowerControl::Alpha", DoubleValue (1.0));
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
 
-  uint8_t bandwidth = 25;
+  uint16_t bandwidth = 25;
   double d1 = 0;
 
   // Create Nodes: eNodeB and UE
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-x2-handover.cc ns-3.31/src/lte/examples/lena-x2-handover.cc
--- ns-3.30.1/src/lte/examples/lena-x2-handover.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-x2-handover.cc	2020-06-27 17:38:30.000000000 -0700
@@ -127,8 +127,10 @@
   // LogComponentEnable ("LteHelper", logLevel);
   // LogComponentEnable ("EpcHelper", logLevel);
   // LogComponentEnable ("EpcEnbApplication", logLevel);
+  // LogComponentEnable ("EpcMmeApplication", logLevel);
+  // LogComponentEnable ("EpcPgwApplication", logLevel);
+  // LogComponentEnable ("EpcSgwApplication", logLevel);
   // LogComponentEnable ("EpcX2", logLevel);
-  // LogComponentEnable ("EpcSgwPgwApplication", logLevel);
 
   // LogComponentEnable ("LteEnbRrc", logLevel);
   // LogComponentEnable ("LteEnbNetDevice", logLevel);
@@ -151,7 +153,7 @@
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (false));
 
   // Command line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("numberOfUes", "Number of UEs", numberOfUes);
   cmd.AddValue ("numberOfEnbs", "Number of eNodeBs", numberOfEnbs);
   cmd.AddValue ("simTime", "Total duration of the simulation", simTime);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/examples/lena-x2-handover-measures.cc ns-3.31/src/lte/examples/lena-x2-handover-measures.cc
--- ns-3.30.1/src/lte/examples/lena-x2-handover-measures.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/examples/lena-x2-handover-measures.cc	2020-06-27 17:38:30.000000000 -0700
@@ -129,8 +129,10 @@
   // LogComponentEnable ("LteHelper", logLevel);
   // LogComponentEnable ("EpcHelper", logLevel);
   // LogComponentEnable ("EpcEnbApplication", logLevel);
+  // LogComponentEnable ("EpcMmeApplication", logLevel);
+  // LogComponentEnable ("EpcPgwApplication", logLevel);
+  // LogComponentEnable ("EpcSgwApplication", logLevel);
   // LogComponentEnable ("EpcX2", logLevel);
-  // LogComponentEnable ("EpcSgwPgwApplication", logLevel);
 
   // LogComponentEnable ("LteEnbRrc", logLevel);
   // LogComponentEnable ("LteEnbNetDevice", logLevel);
@@ -156,7 +158,7 @@
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
 
   // Command line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("simTime", "Total duration of the simulation (in seconds)", simTime);
   cmd.AddValue ("speed", "Speed of the UE (default = 20 m/s)", speed);
   cmd.AddValue ("enbTxPowerDbm", "TX power [dBm] used by HeNBs (default = 46.0)", enbTxPowerDbm);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/cc-helper.cc ns-3.31/src/lte/helper/cc-helper.cc
--- ns-3.30.1/src/lte/helper/cc-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/cc-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -175,7 +175,7 @@
 
   uint32_t ulEarfcn = m_ulEarfcn;
   uint32_t dlEarfcn = m_dlEarfcn;
-  uint32_t maxBandwidthRb = std::max<uint32_t> (m_ulBandwidth, m_dlBandwidth);
+  uint16_t maxBandwidthRb = std::max<uint16_t> (m_ulBandwidth, m_dlBandwidth);
 
   // Convert bandwidth from RBs to kHz
   uint32_t maxBandwidthKhz = LteSpectrumValueHelper::GetChannelBandwidth(maxBandwidthRb) / 1e3;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/epc-helper.h ns-3.31/src/lte/helper/epc-helper.h
--- ns-3.30.1/src/lte/helper/epc-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/epc-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -35,9 +35,7 @@
 class Node;
 class NetDevice;
 class VirtualNetDevice;
-class EpcSgwPgwApplication;
 class EpcX2;
-class EpcMme;
 
 /**
  * \ingroup lte
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/lte-helper.cc ns-3.31/src/lte/helper/lte-helper.cc
--- ns-3.30.1/src/lte/helper/lte-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/lte-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -709,9 +709,9 @@
       ccPhy->GetDlSpectrumPhy ()->SetDevice (dev);
       ccPhy->GetUlSpectrumPhy ()->SetLtePhyRxDataEndOkCallback (MakeCallback (&LteEnbPhy::PhyPduReceived, ccPhy));
       ccPhy->GetUlSpectrumPhy ()->SetLtePhyRxCtrlEndOkCallback (MakeCallback (&LteEnbPhy::ReceiveLteControlMessageList, ccPhy));
-      ccPhy->GetUlSpectrumPhy ()->SetLtePhyUlHarqFeedbackCallback (MakeCallback (&LteEnbPhy::ReceiveLteUlHarqFeedback, ccPhy));
+      ccPhy->GetUlSpectrumPhy ()->SetLtePhyUlHarqFeedbackCallback (MakeCallback (&LteEnbPhy::ReportUlHarqFeedback, ccPhy));
       NS_LOG_LOGIC ("set the propagation model frequencies");
-      double dlFreq = LteSpectrumValueHelper::GetCarrierFrequency (it->second->m_dlEarfcn);
+      double dlFreq = LteSpectrumValueHelper::GetCarrierFrequency (it->second->GetDlEarfcn ());
       NS_LOG_LOGIC ("DL freq: " << dlFreq);
       bool dlFreqOk = m_downlinkPathlossModel->SetAttributeFailSafe ("Frequency", DoubleValue (dlFreq));
       if (!dlFreqOk)
@@ -719,7 +719,7 @@
           NS_LOG_WARN ("DL propagation model does not have a Frequency attribute");
         }
 
-      double ulFreq = LteSpectrumValueHelper::GetCarrierFrequency (it->second->m_ulEarfcn);
+      double ulFreq = LteSpectrumValueHelper::GetCarrierFrequency (it->second->GetUlEarfcn ());
 
       NS_LOG_LOGIC ("UL freq: " << ulFreq);
       bool ulFreqOk = m_uplinkPathlossModel->SetAttributeFailSafe ("Frequency", DoubleValue (ulFreq));
@@ -937,7 +937,7 @@
       ccPhy->GetDlSpectrumPhy ()->SetLtePhyRxDataEndOkCallback (MakeCallback (&LteUePhy::PhyPduReceived, ccPhy));
       ccPhy->GetDlSpectrumPhy ()->SetLtePhyRxCtrlEndOkCallback (MakeCallback (&LteUePhy::ReceiveLteControlMessageList, ccPhy));
       ccPhy->GetDlSpectrumPhy ()->SetLtePhyRxPssCallback (MakeCallback (&LteUePhy::ReceivePss, ccPhy));
-      ccPhy->GetDlSpectrumPhy ()->SetLtePhyDlHarqFeedbackCallback (MakeCallback (&LteUePhy::ReceiveLteDlHarqFeedback, ccPhy));
+      ccPhy->GetDlSpectrumPhy ()->SetLtePhyDlHarqFeedbackCallback (MakeCallback (&LteUePhy::EnqueueDlHarqFeedback, ccPhy));
     }
 
   nas->SetDevice (dev);
@@ -1295,7 +1295,7 @@
 }
 
 void
-LteHelper::DoComponentCarrierConfigure (uint32_t ulEarfcn, uint32_t dlEarfcn, uint8_t ulbw, uint8_t dlbw)
+LteHelper::DoComponentCarrierConfigure (uint32_t ulEarfcn, uint32_t dlEarfcn, uint16_t ulbw, uint16_t dlbw)
 {
   NS_LOG_FUNCTION (this << ulEarfcn << dlEarfcn << ulbw << dlbw);
 
@@ -1335,8 +1335,9 @@
   LogComponentEnable ("ComponentCarrierUe", LOG_LEVEL_ALL);
   LogComponentEnable ("CqaFfMacScheduler", LOG_LEVEL_ALL);
   LogComponentEnable ("EpcEnbApplication", LOG_LEVEL_ALL);
-  LogComponentEnable ("EpcMme", LOG_LEVEL_ALL);
-  LogComponentEnable ("EpcSgwPgwApplication", LOG_LEVEL_ALL);
+  LogComponentEnable ("EpcMmeApplication", LOG_LEVEL_ALL);
+  LogComponentEnable ("EpcPgwApplication", LOG_LEVEL_ALL);
+  LogComponentEnable ("EpcSgwApplication", LOG_LEVEL_ALL);
   LogComponentEnable ("EpcTft", LOG_LEVEL_ALL);
   LogComponentEnable ("EpcTftClassifier", LOG_LEVEL_ALL);
   LogComponentEnable ("EpcUeNas", LOG_LEVEL_ALL);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/lte-helper.h ns-3.31/src/lte/helper/lte-helper.h
--- ns-3.30.1/src/lte/helper/lte-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/lte-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -684,7 +684,7 @@
    * \param ulbw uplink bandwidth for each CC
    * \param dlbw downlink bandwidth for each CC
    */
-  void DoComponentCarrierConfigure (uint32_t ulEarfcn, uint32_t dlEarfcn, uint8_t ulbw, uint8_t dlbw);
+  void DoComponentCarrierConfigure (uint32_t ulEarfcn, uint32_t dlEarfcn, uint16_t ulbw, uint16_t dlbw);
   /**
    * Create an eNodeB device (LteEnbNetDevice) on the given node.
    * \param n the node where the device is to be installed
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/radio-bearer-stats-connector.cc ns-3.31/src/lte/helper/radio-bearer-stats-connector.cc
--- ns-3.30.1/src/lte/helper/radio-bearer-stats-connector.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/radio-bearer-stats-connector.cc	2020-06-27 17:38:30.000000000 -0700
@@ -309,10 +309,14 @@
       arg->imsi = imsi;
       arg->cellId = cellId;
       arg->stats = m_pdcpStats;
-      Config::Connect (basePath + "/LtePdcp/TxPDU",
+      bool foundTxPdcp = Config::ConnectFailSafe (basePath + "/LtePdcp/TxPDU",
                        MakeBoundCallback (&DlTxPduCallback, arg));
-      Config::Connect (basePath + "/LtePdcp/RxPDU",
+      bool foundRxPdcp = Config::ConnectFailSafe (basePath + "/LtePdcp/RxPDU",
                        MakeBoundCallback (&UlRxPduCallback, arg));
+      if (!foundTxPdcp && !foundRxPdcp)
+        {
+          NS_LOG_WARN ("Unable to connect PDCP traces. This may happen if RlcSm is used");
+        }
     }
 }
 
@@ -341,10 +345,14 @@
       arg->imsi = imsi;
       arg->cellId = cellId;
       arg->stats = m_pdcpStats;
-      Config::Connect (basePath + "/LtePdcp/TxPDU",
+      bool foundTxPdcp = Config::ConnectFailSafe (basePath + "/LtePdcp/TxPDU",
                        MakeBoundCallback (&UlTxPduCallback, arg));
-      Config::Connect (basePath + "/LtePdcp/RxPDU",
+      bool foundRxPdcp = Config::ConnectFailSafe (basePath + "/LtePdcp/RxPDU",
                        MakeBoundCallback (&DlRxPduCallback, arg));
+      if (!foundTxPdcp && !foundRxPdcp)
+        {
+          NS_LOG_WARN ("Unable to connect PDCP traces. This may happen if RlcSm is used");
+        }
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/radio-environment-map-helper.cc ns-3.31/src/lte/helper/radio-environment-map-helper.cc
--- ns-3.30.1/src/lte/helper/radio-environment-map-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/radio-environment-map-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -149,14 +149,14 @@
 }
 
 
-uint8_t 
+uint16_t
 RadioEnvironmentMapHelper::GetBandwidth () const
 {
   return m_bandwidth;
 }
 
 void 
-RadioEnvironmentMapHelper::SetBandwidth (uint8_t bw)
+RadioEnvironmentMapHelper::SetBandwidth (uint16_t bw)
 {
   switch (bw)
     { 
@@ -170,7 +170,7 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("invalid bandwidth value " << bw);
       break;
     }
 }
@@ -292,7 +292,8 @@
         {
           NS_ASSERT (remIt != m_rem.end ());
           remIt->bmm->SetPosition (Vector (x, y, m_z));
-          BuildingsHelper::MakeConsistent (remIt->bmm);
+          Ptr <MobilityBuildingInfo> buildingInfo = (remIt->bmm)->GetObject <MobilityBuildingInfo> ();
+          buildingInfo->MakeConsistent (remIt->bmm);
           ++remIt;
         }      
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/helper/radio-environment-map-helper.h ns-3.31/src/lte/helper/radio-environment-map-helper.h
--- ns-3.30.1/src/lte/helper/radio-environment-map-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/helper/radio-environment-map-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -61,13 +61,13 @@
   /** 
    * \return the bandwidth (in num of RBs) over which SINR is calculated
    */
-  uint8_t GetBandwidth () const;
+  uint16_t GetBandwidth () const;
 
   /** 
    *
    * \param bw  the bandwidth (in num of RBs) over which SINR is calculated
    */
-  void SetBandwidth (uint8_t bw);
+  void SetBandwidth (uint16_t bw);
 
   /** 
    * Deploy the RemSpectrumPhy objects that generate the map according to the specified settings.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/component-carrier.cc ns-3.31/src/lte/model/component-carrier.cc
--- ns-3.30.1/src/lte/model/component-carrier.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/component-carrier.cc	2020-06-27 17:38:30.000000000 -0700
@@ -21,11 +21,8 @@
 #include "component-carrier.h"
 #include <ns3/uinteger.h>
 #include <ns3/boolean.h>
-#include <ns3/simulator.h>
 #include <ns3/log.h>
 #include <ns3/abort.h>
-#include <ns3/lte-enb-phy.h>
-#include <ns3/pointer.h>
 
 namespace ns3 {
 
@@ -56,13 +53,15 @@
                    "Downlink E-UTRA Absolute Radio Frequency Channel Number (EARFCN) "
                    "as per 3GPP 36.101 Section 5.7.3. ",
                    UintegerValue (100),
-                   MakeUintegerAccessor (&ComponentCarrier::m_dlEarfcn),
+                   MakeUintegerAccessor (&ComponentCarrier::SetDlEarfcn,
+                                         &ComponentCarrier::GetDlEarfcn),
                    MakeUintegerChecker<uint32_t> (0, 262143))
     .AddAttribute ("UlEarfcn",
                    "Uplink E-UTRA Absolute Radio Frequency Channel Number (EARFCN) "
                    "as per 3GPP 36.101 Section 5.7.3. ",
                    UintegerValue (18100),
-                   MakeUintegerAccessor (&ComponentCarrier::m_ulEarfcn),
+                   MakeUintegerAccessor (&ComponentCarrier::SetUlEarfcn,
+                                         &ComponentCarrier::GetUlEarfcn),
                    MakeUintegerChecker<uint32_t> (18000, 262143))
     .AddAttribute ("CsgId",
                    "The Closed Subscriber Group (CSG) identity that this eNodeB belongs to",
@@ -88,8 +87,7 @@
   ;
   return tid;
 }
-ComponentCarrier::ComponentCarrier ()
-  : m_isConstructed (false)
+ComponentCarrier::ComponentCarrier () : Object ()
 {
   NS_LOG_FUNCTION (this);
 }
@@ -106,16 +104,16 @@
   Object::DoDispose ();
 }
 
-uint8_t
+uint16_t
 ComponentCarrier::GetUlBandwidth () const
 {
   return m_ulBandwidth;
 }
 
 void
-ComponentCarrier::SetUlBandwidth (uint8_t bw)
+ComponentCarrier::SetUlBandwidth (uint16_t bw)
 {
-  NS_LOG_FUNCTION (this << uint16_t (bw));
+  NS_LOG_FUNCTION (this << bw);
   switch (bw)
     {
     case 6:
@@ -128,21 +126,21 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("Invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("Invalid bandwidth value " << bw);
       break;
     }
 }
 
-uint8_t
+uint16_t
 ComponentCarrier::GetDlBandwidth () const
 {
   return m_dlBandwidth;
 }
 
 void
-ComponentCarrier::SetDlBandwidth (uint8_t bw)
+ComponentCarrier::SetDlBandwidth (uint16_t bw)
 {
-  NS_LOG_FUNCTION (this << uint16_t (bw));
+  NS_LOG_FUNCTION (this << bw);
   switch (bw)
     {
     case 6:
@@ -155,7 +153,7 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("Invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("Invalid bandwidth value " << bw);
       break;
     }
 }
@@ -225,11 +223,42 @@
   m_primaryCarrier = primaryCarrier;
 }
 
-void
-ComponentCarrier::DoInitialize (void)
+//====================================================
+
+NS_OBJECT_ENSURE_REGISTERED (ComponentCarrierBaseStation);
+
+TypeId ComponentCarrierBaseStation::GetTypeId (void)
+{
+  static TypeId
+    tid =
+    TypeId ("ns3::ComponentCarrierBaseStation")
+    .SetParent<ComponentCarrier> ()
+    .AddConstructor<ComponentCarrierBaseStation> ()
+  ;
+  return tid;
+}
+
+ComponentCarrierBaseStation::ComponentCarrierBaseStation () : ComponentCarrier ()
 {
   NS_LOG_FUNCTION (this);
-  m_isConstructed = true;
+}
+
+ComponentCarrierBaseStation::~ComponentCarrierBaseStation (void)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+uint16_t
+ComponentCarrierBaseStation::GetCellId ()
+{
+  return m_cellId;
+}
+
+void
+ComponentCarrierBaseStation::SetCellId (uint16_t cellId)
+{
+  NS_LOG_FUNCTION (this << cellId);
+  m_cellId = cellId;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/component-carrier-enb.cc ns-3.31/src/lte/model/component-carrier-enb.cc
--- ns-3.30.1/src/lte/model/component-carrier-enb.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/component-carrier-enb.cc	2020-06-27 17:38:30.000000000 -0700
@@ -108,7 +108,6 @@
 ComponentCarrierEnb::DoInitialize (void)
 {
   NS_LOG_FUNCTION (this);
-  m_isConstructed = true;
   m_phy->Initialize ();
   m_mac->Initialize ();
   m_ffrAlgorithm->Initialize ();
@@ -170,40 +169,6 @@
 {
   NS_LOG_FUNCTION (this);
   m_scheduler = s;
-} 
-
-TypeId ComponentCarrierBaseStation::GetTypeId (void)
-{
-  static TypeId
-    tid =
-    TypeId ("ns3::ComponentCarrierBaseStation")
-    .SetParent<ComponentCarrier> ()
-    .AddConstructor<ComponentCarrierBaseStation> ()
-  ;
-  return tid;
-}
-
-ComponentCarrierBaseStation::ComponentCarrierBaseStation ()
-{
-  NS_LOG_FUNCTION (this);
-}
-
-ComponentCarrierBaseStation::~ComponentCarrierBaseStation (void)
-{
-  NS_LOG_FUNCTION (this);
-}
-
-uint16_t
-ComponentCarrierBaseStation::GetCellId ()
-{
-  return m_cellId;
-}
-
-void
-ComponentCarrierBaseStation::SetCellId (uint16_t cellId)
-{
-  NS_LOG_FUNCTION (this << cellId);
-  m_cellId = cellId;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/component-carrier.h ns-3.31/src/lte/model/component-carrier.h
--- ns-3.30.1/src/lte/model/component-carrier.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/component-carrier.h	2020-06-27 17:38:30.000000000 -0700
@@ -23,11 +23,6 @@
 #define COMPONENT_CARRIER_H
 
 #include <ns3/object.h>
-#include <ns3/packet.h>
-#include <ns3/nstime.h>
-#include "ns3/lte-phy.h"
-#include <ns3/lte-enb-phy.h>
-#include <ns3/pointer.h>
 
 namespace ns3 {
 
@@ -58,22 +53,22 @@
   /**
    * \return the uplink bandwidth in RBs
    */
-  uint8_t GetUlBandwidth () const;
+  uint16_t GetUlBandwidth () const;
 
   /**
    * \param bw the uplink bandwidth in RBs
    */
-  virtual void SetUlBandwidth (uint8_t bw);
+  virtual void SetUlBandwidth (uint16_t bw);
 
   /**
    * \return the downlink bandwidth in RBs
    */
-  uint8_t GetDlBandwidth () const;
+  uint16_t GetDlBandwidth () const;
 
   /**
    * \param bw the downlink bandwidth in RBs
    */
-  virtual void SetDlBandwidth (uint8_t bw);
+  virtual void SetDlBandwidth (uint16_t bw);
 
   /**
    * \return the downlink carrier frequency (EARFCN)
@@ -152,23 +147,17 @@
    */
   bool IsPrimary () const;
 
+protected:
+  uint32_t m_csgId {0}; ///< CSG ID
+  bool m_csgIndication {false}; ///< CSG indication
 
-  uint8_t m_dlBandwidth;   /**< downlink bandwidth in RBs */
-  uint8_t m_ulBandwidth;   /**< uplink bandwidth in RBs */
-
-  uint32_t m_dlEarfcn;    /**< downlink carrier frequency */
-  uint32_t m_ulEarfcn;    /**< uplink carrier frequency */
+  bool m_primaryCarrier {false}; ///< whether the carrier is primary
 
-protected:
-  // inherited from Object
-  virtual void DoInitialize (void);
-  uint16_t m_csgId; ///< CSG ID
-  bool m_csgIndication; ///< CSG indication
-
-  bool m_primaryCarrier; ///< whether the carrier is primary
-  bool m_isConstructed; ///< whether the instance is constructed
-//    bool m_isConfigured;
+  uint16_t m_dlBandwidth {0};   ///< downlink bandwidth in RBs */
+  uint16_t m_ulBandwidth {0};   ///< uplink bandwidth in RBs */
 
+  uint32_t m_dlEarfcn {0};    ///< downlink carrier frequency */
+  uint32_t m_ulEarfcn {0};    ///< uplink carrier frequency */
 };
 
 /**
@@ -186,9 +175,15 @@
    */
   static TypeId GetTypeId (void);
 
+  /**
+   * \brief Constructor
+   */
   ComponentCarrierBaseStation ();
 
-  virtual ~ComponentCarrierBaseStation (void);
+  /**
+   * \brief ~ComponentCarrierBaseStation
+   */
+  virtual ~ComponentCarrierBaseStation (void) override;
 
   /**
    * Get cell identifier
@@ -203,7 +198,7 @@
   void SetCellId (uint16_t cellId);
 
 protected:
-  uint16_t m_cellId; ///< Cell identifier
+  uint16_t m_cellId {0}; ///< Cell identifier
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/component-carrier-ue.cc ns-3.31/src/lte/model/component-carrier-ue.cc
--- ns-3.30.1/src/lte/model/component-carrier-ue.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/component-carrier-ue.cc	2020-06-27 17:38:30.000000000 -0700
@@ -80,7 +80,6 @@
 ComponentCarrierUe::DoInitialize (void)
 {
   NS_LOG_FUNCTION (this);
-  m_isConstructed = true;
   m_phy->Initialize ();
   m_mac->Initialize();
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/epc-gtpc-header.cc ns-3.31/src/lte/model/epc-gtpc-header.cc
--- ns-3.30.1/src/lte/model/epc-gtpc-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/epc-gtpc-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -874,14 +874,14 @@
   os << " imsi " << m_imsi << " uliEcgi " << m_uliEcgi;
 }
 
-uint8_t
+uint64_t
 GtpcModifyBearerRequestMessage::GetImsi () const
 {
   return m_imsi;
 }
 
 void
-GtpcModifyBearerRequestMessage::SetImsi (uint8_t imsi)
+GtpcModifyBearerRequestMessage::SetImsi (uint64_t imsi)
 {
   m_imsi = imsi;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/epc-gtpc-header.h ns-3.31/src/lte/model/epc-gtpc-header.h
--- ns-3.30.1/src/lte/model/epc-gtpc-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/epc-gtpc-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -334,8 +334,8 @@
   virtual void Print (std::ostream &os) const;
   virtual uint32_t GetMessageSize (void) const;
 
-  uint8_t GetImsi () const;
-  void SetImsi (uint8_t imsi);
+  uint64_t GetImsi () const;
+  void SetImsi (uint64_t imsi);
 
   uint32_t GetUliEcgi () const;
   void SetUliEcgi (uint32_t uliEcgi);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/epc-pgw-application.cc ns-3.31/src/lte/model/epc-pgw-application.cc
--- ns-3.30.1/src/lte/model/epc-pgw-application.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/epc-pgw-application.cc	2020-06-27 17:38:30.000000000 -0700
@@ -290,7 +290,7 @@
   packet->RemoveHeader (msg);
   uint64_t imsi = msg.GetImsi ();
   uint16_t cellId = msg.GetUliEcgi ();
-  NS_LOG_DEBUG ("cellId " << cellId << " imsi " << (uint16_t)imsi);
+  NS_LOG_DEBUG ("cellId " << cellId << " IMSI " << imsi);
 
   std::map<uint64_t, Ptr<UeInfo> >::iterator ueit = m_ueInfoByImsiMap.find (imsi);
   NS_ASSERT_MSG (ueit != m_ueInfoByImsiMap.end (), "unknown IMSI " << imsi);
@@ -351,9 +351,9 @@
 
   GtpcModifyBearerRequestMessage msg;
   packet->RemoveHeader (msg);
-  uint8_t imsi = msg.GetImsi ();
+  uint64_t imsi = msg.GetImsi ();
   uint16_t cellId = msg.GetUliEcgi ();
-  NS_LOG_DEBUG ("cellId " << cellId << "IMSI " << (uint16_t)imsi);
+  NS_LOG_DEBUG ("cellId " << cellId << " IMSI " << imsi);
 
   std::map<uint64_t, Ptr<UeInfo> >::iterator ueit = m_ueInfoByImsiMap.find (imsi);
   NS_ASSERT_MSG (ueit != m_ueInfoByImsiMap.end (), "unknown IMSI " << imsi); 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/epc-sgw-application.cc ns-3.31/src/lte/model/epc-sgw-application.cc
--- ns-3.30.1/src/lte/model/epc-sgw-application.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/epc-sgw-application.cc	2020-06-27 17:38:30.000000000 -0700
@@ -231,9 +231,9 @@
 
   GtpcCreateSessionRequestMessage msg;
   packet->RemoveHeader (msg);
-  uint8_t imsi = msg.GetImsi ();
+  uint64_t imsi = msg.GetImsi ();
   uint16_t cellId = msg.GetUliEcgi ();
-  NS_LOG_DEBUG ("IMSI " << (uint16_t)imsi << " cellId " << cellId);
+  NS_LOG_DEBUG ("cellId " << cellId << " IMSI " << imsi);
 
   std::map<uint16_t, EnbInfo>::iterator enbit = m_enbInfoByCellId.find (cellId);
   NS_ASSERT_MSG (enbit != m_enbInfoByCellId.end (), "unknown CellId " << cellId); 
@@ -298,9 +298,9 @@
 
   GtpcModifyBearerRequestMessage msg;
   packet->RemoveHeader (msg);
-  uint8_t imsi = msg.GetImsi ();
+  uint64_t imsi = msg.GetImsi ();
   uint16_t cellId = msg.GetUliEcgi ();
-  NS_LOG_DEBUG ("IMSI " << (uint16_t)imsi << " cellId " << cellId);
+  NS_LOG_DEBUG ("cellId " << cellId << " IMSI " << imsi);
 
   std::map<uint16_t, EnbInfo>::iterator enbit = m_enbInfoByCellId.find (cellId);
   NS_ASSERT_MSG (enbit != m_enbInfoByCellId.end (), "unknown CellId " << cellId); 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/ff-mac-csched-sap.h ns-3.31/src/lte/model/ff-mac-csched-sap.h
--- ns-3.30.1/src/lte/model/ff-mac-csched-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/ff-mac-csched-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -84,8 +84,8 @@
 
     struct SiConfiguration_s m_siConfiguration; ///< SI configuration
 
-    uint8_t m_ulBandwidth; ///< UL bandwidth
-    uint8_t m_dlBandwidth; ///< DL badnwidth
+    uint16_t m_ulBandwidth; ///< UL bandwidth
+    uint16_t m_dlBandwidth; ///< DL badnwidth
 
     enum NormalExtended_e m_ulCyclicPrefixLength; ///< UL cyclic prefix length
     enum NormalExtended_e m_dlCyclicPrefixLength; ///< DL cyclic prefix length
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-cmac-sap.h ns-3.31/src/lte/model/lte-enb-cmac-sap.h
--- ns-3.30.1/src/lte/model/lte-enb-cmac-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-cmac-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -48,8 +48,8 @@
    * @param ulBandwidth
    * @param dlBandwidth
    */
-  virtual void ConfigureMac (uint8_t ulBandwidth,
-                             uint8_t dlBandwidth) = 0;
+  virtual void ConfigureMac (uint16_t ulBandwidth,
+                             uint16_t dlBandwidth) = 0;
 
   /**
    * Add UE function
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-cphy-sap.h ns-3.31/src/lte/model/lte-enb-cphy-sap.h
--- ns-3.30.1/src/lte/model/lte-enb-cphy-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-cphy-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
    * \param ulBandwidth the UL bandwidth in PRBs
    * \param dlBandwidth the DL bandwidth in PRBs
    */
-  virtual void SetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth) = 0;
+  virtual void SetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth) = 0;
 
   /**
    * \param ulEarfcn the UL EARFCN
@@ -155,7 +155,7 @@
 
   // inherited from LteEnbCphySapProvider
   virtual void SetCellId (uint16_t cellId);
-  virtual void SetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth);
+  virtual void SetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth);
   virtual void SetEarfcn (uint32_t ulEarfcn, uint32_t dlEarfcn);
   virtual void AddUe (uint16_t rnti);
   virtual void RemoveUe (uint16_t rnti);
@@ -192,7 +192,7 @@
 
 template <class C>
 void 
-MemberLteEnbCphySapProvider<C>::SetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth)
+MemberLteEnbCphySapProvider<C>::SetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
   m_owner->DoSetBandwidth (ulBandwidth, dlBandwidth);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-mac.cc ns-3.31/src/lte/model/lte-enb-mac.cc
--- ns-3.30.1/src/lte/model/lte-enb-mac.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -67,7 +67,7 @@
   EnbMacMemberLteEnbCmacSapProvider (LteEnbMac* mac);
 
   // inherited from LteEnbCmacSapProvider
-  virtual void ConfigureMac (uint8_t ulBandwidth, uint8_t dlBandwidth);
+  virtual void ConfigureMac (uint16_t ulBandwidth, uint16_t dlBandwidth);
   virtual void AddUe (uint16_t rnti);
   virtual void RemoveUe (uint16_t rnti);
   virtual void AddLc (LcInfo lcinfo, LteMacSapUser* msu);
@@ -89,7 +89,7 @@
 }
 
 void
-EnbMacMemberLteEnbCmacSapProvider::ConfigureMac (uint8_t ulBandwidth, uint8_t dlBandwidth)
+EnbMacMemberLteEnbCmacSapProvider::ConfigureMac (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
   m_mac->DoConfigureMac (ulBandwidth, dlBandwidth);
 }
@@ -789,9 +789,9 @@
 // ////////////////////////////////////////////
 
 void
-LteEnbMac::DoConfigureMac (uint8_t ulBandwidth, uint8_t dlBandwidth)
+LteEnbMac::DoConfigureMac (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
-  NS_LOG_FUNCTION (this << " ulBandwidth=" << (uint16_t) ulBandwidth << " dlBandwidth=" << (uint16_t) dlBandwidth);
+  NS_LOG_FUNCTION (this << " ulBandwidth=" << ulBandwidth << " dlBandwidth=" << dlBandwidth);
   FfMacCschedSapProvider::CschedCellConfigReqParameters params;
   // Configure the subset of parameters used by FfMacScheduler
   params.m_ulBandwidth = ulBandwidth;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-mac.h ns-3.31/src/lte/model/lte-enb-mac.h
--- ns-3.30.1/src/lte/model/lte-enb-mac.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -217,7 +217,7 @@
   * \param ulBandwidth the UL bandwidth
   * \param dlBandwidth the DL bandwidth
   */
-  void DoConfigureMac (uint8_t ulBandwidth, uint8_t dlBandwidth);
+  void DoConfigureMac (uint16_t ulBandwidth, uint16_t dlBandwidth);
   /**
   * \brief Add UE function
   * \param rnti the RNTI
